# -*- coding: utf-8 -*-
"""
Created on Tue Feb 27 13:11:34 2024

@author: aleja
"""
import numpy as np
import pandas as pd
import matplotlib.pyplot as plt
from scipy.stats import norm, kurtosis
from scipy.stats import skew

variables = np.load('fich_datos_SPA.npz')

p=variables['p']
sa=variables['sa']
Qumbral=variables['Qumbral']
Tumbral=variables['Tumbral']
valor_medio=variables['valor_medio']
desviacion_estandar1=variables['desviacion_estandar']
kv=variables['kv']

Qumbral=250

datos = pd.read_csv('d07_te.csv')

shape = datos.shape
n=len(datos.axes[0])
m=len(datos.axes[1])


conjunto_muestras = []
conjunto_medias=[]
conjunto_desviacion_estandar=[]
conjunto_correlacion=[]
conjunto_skewness=[]
conjunto_kurtosis=[]

for i in range(1, n-(kv-1)):
    muestra = datos.iloc[i:i+kv, :] #el iloc es por los datos en panda
    muestra = np.array(muestra, dtype=np.float64)  # convert to numpy array of float64
    conjunto_muestras.append(muestra)  # append the numpy array

    media = np.mean(muestra,axis=0)  # calculate mean of the entire matrix
    conjunto_medias.append(media)  # append the mean to the list

    desviacion_estandar=np.std(muestra,axis=0)
    desviacion_estandar=desviacion_estandar**2
    conjunto_desviacion_estandar.append(desviacion_estandar)  
    
    #correlacion = np.corrcoef(muestra)
    #tri_sup = np.triu(correlacion, k=1)
    #tri_elementos = tri_sup[tri_sup > 0.3]
    #conjunto_correlacion.append(tri_elementos)
    
    skewness = skew(muestra,axis=0)
    conjunto_skewness.append(skewness)
    
    kurtosiss = kurtosis(muestra, axis=0)
    conjunto_kurtosis.append(kurtosiss)
    
#para que tengan forma array of float64
conjunto_muestras = np.concatenate(conjunto_muestras, axis=0)#para comprobar
conjunto_medias=np.array(conjunto_medias,dtype=np.float64)
conjunto_desviacion_estandar=np.array(conjunto_desviacion_estandar,dtype=np.float64)
conjunto_skewness=np.array(conjunto_skewness,dtype=np.float64)
conjunto_kurtosis=np.array(conjunto_kurtosis,dtype=np.float64)



# Crea una lista de las 4 matrices
matrices = [conjunto_medias, conjunto_desviacion_estandar,conjunto_skewness,conjunto_kurtosis]

# Para intercalar, tomaremos una columna de cada matriz a la vez y las concatenaremos
#datos_nueva = np.hstack([matrices[i][:, j].reshape(n-kv, 1) for j in range(52) for i in range(4)])
datos_nueva=np.concatenate((conjunto_medias, conjunto_desviacion_estandar,conjunto_skewness), axis=1)
datos_nueva=np.concatenate((datos_nueva,conjunto_kurtosis), axis=1)
#datos_nueva=np.concatenate((datos_nueva,conjunto_kurtosis,conjunto_correlacion), axis=1)
n,m=datos_nueva.shape





#2 normalizar a media conocida y varianza 1
#valor_medio = datos_nueva.mean(axis=0)
variable_centralizada = datos_nueva - valor_medio

#desviacion_estandar = datos_nueva.std(axis=0)

Xn = variable_centralizada / desviacion_estandar1

T2=[]
for i in range (n):
    
    multi=np.dot(np.dot(np.dot(np.dot(Xn[i,:], p), np.linalg.inv(sa)), np.transpose(p)), np.transpose(Xn[i,:]))

    T2=np.append(T2,multi)
    
  
 #calcular la estadistica Q

Q=[]

for i in range(n):
    R=Xn[i,:]-np.dot(np.dot(Xn[i,:],p),np.transpose(p))
    Rt=np.transpose(R) #para que de la forma adecuada
    Qi=np.dot(Rt,R)
    Q=np.append(Q,Qi)
    
    
ejex=np.arange(n)

plt.title('Estadistico T^2 de Hotelling')
plt.xlabel('t')
plt.ylabel('T^2')
plt.scatter(ejex, T2, c ="green")
plt.axhline(y=Tumbral, color="r", label="Percentil 99")
plt.show()


plt.title('Estadistico Q')
plt.xlabel('t')
plt.ylabel('Q')
plt.scatter(ejex, Q, c ="blue")
plt.axhline(y=Qumbral, color="r", label="Percentil 99")
plt.show()  


#detectar fallos
t_falloT=0
con=0
k=10
fallo=0
for i in range (0,n):
    if T2[i]>Tumbral:
        con=con+1
    else:
        con=0
        
    if con==k:
        fallo =1
        t_falloT=i-9
        break
    
    
print('tiempo para T2',t_falloT)  

  
con=0    
t_falloQ=0
for i in range (0,n):
    if Q[i]>Qumbral:
         con=con+1
    else:
         con=0
        
    if con==k:
        fallo =1
        t_falloQ=i-9
        break
    
#print('tiempo para Q',t_falloQ)
#falsas alarmas
cont=0
for i in range(109-kv): #antes 159
    if T2[i]>Tumbral:
        cont=cont+1

falsa_alarmaT=cont/(110-kv)*100  #########cambiado por 110

print('falsas alarmas para T2',falsa_alarmaT)

cont2=0
for i in range(109-kv):
    if Q[i]>Qumbral:
        cont2=cont2+1

falsa_alarmaQ=cont2/(110-kv)*100 #cambiado el 160 por 110

#print('falsas alarmas para Q',falsa_alarmaQ)

#alarmas detectadas
con=0
for i in range (160-kv,n):
    if T2[i]>Tumbral:
        con=con+1

alarma_detectadaT=con/800*100
print(' alarmas detectadas para T2',alarma_detectadaT)

con2=0
for i in range (160-kv,n):
    if Q[i]>Qumbral:
        con2=con2+1

alarma_detectadaQ=con2/800*100
#print(' alarmas detectadas para Q',alarma_detectadaQ)


print('tiempo para Q',t_falloQ)
print('falsas alarmas para Q',falsa_alarmaQ)
print(' alarmas detectadas para Q',alarma_detectadaQ)
#################### identificacion fallo

#R_fallo=Xn[t_falloQ,:]
R_fallo=Xn[t_falloQ,:]-np.dot(np.dot(Xn[t_falloQ,:],p),np.transpose(p))

R_fallo2=np.square(R_fallo)
max_valor = np.max(R_fallo2)
max_indice = np.argmax(R_fallo2)
print(f'posición {max_indice}')

plt.bar(range(len(R_fallo2)), R_fallo2)
plt.title('SPA Diagrama de barras de R_fallo2 d12')
plt.show()


